VirtualCarGarage/VirtualCarGarage/Models/ServiceHistoryViewModel.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace VirtualCarGarage.MVC.Models
{
    public class ServiceHistoryViewModel
    {
        public int ServiceHistoryId { get; set; }
        public int CarId { get; set; }
        public List<OrderViewModel> Orders { get; set; } 
    }
}

VirtualCarGarage/VirtualCarGarage/Controllers/ServiceHistoriesController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using VirtualCarGarage.Data.Models;
using VirtualCarGarage.MVC.Models;
using VirtualCarGarage.Services.Contracts;
using VirtualCarGarage.Services.Models;

namespace VirtualCarGarage.MVC.Controllers
{
    [Route("[controller]")]
    [Authorize]
    public class ServiceHistoriesController : Controller
    {
        private readonly IServiceHistoryService serviceHistoryService;
        private readonly UserManager<User> userManager;
        private readonly ICarService carService;

        public ServiceHistoriesController(IServiceHistoryService serviceHistoryService, UserManager<User> userManager, ICarService carService)
        {
            this.serviceHistoryService = serviceHistoryService;
            this.userManager = userManager;
            this.carService = carService;
        }

        [HttpGet("Index")]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> Index()
        {

            if (User.IsInRole("Customer"))
            {
                var user = await this.userManager.GetUserAsync(HttpContext.User);

                var userServiceHistories = await this.serviceHistoryService.GetByUserIdAsync(user.Id);

                var userServiceHistoriesView = new List<ServiceHistoryViewModel>();

                foreach (var item in userServiceHistories)
                {
                    userServiceHistoriesView.Add(new ServiceHistoryViewModel
                    {
                        ServiceHistoryId = item.Id,
                        CarId = item.CarId
                    });
                }

                return View(userServiceHistoriesView);
            }

            var serviceHistories = await this.serviceHistoryService.GetAllAsync();

            var serviceHistoriesView = new List<ServiceHistoryViewModel>();

            foreach (var item in serviceHistories)
            {
                serviceHistoriesView.Add(new ServiceHistoryViewModel
                {
                    ServiceHistoryId = item.Id,
                    CarId = item.CarId
                });
            }

            return View(serviceHistoriesView);
        }

        [HttpGet("Create")]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create()
        {
            var cars = await this.carService.GetAllWithoutServiceHistoryAsync();

            var carsView = new List<CarViewModel>();

            foreach (var car in cars)
            {
                carsView.Add(new CarViewModel
                {
                    CarId = car.Id,
                    CarIDNumber = car.VehicleIDNumber,
                    LicensePlate = car.LicensePlate,
                    OwnerName = car.OwnerName,
                    ManufacturerId = car.ManufacturerId,
                    ModelId = car.ModelId,
                    OwnerId = car.UserId,
                    YearOfManufacture = car.YearOfManufacture
                });
            }

            ViewData["CarId"] = new SelectList(carsView, "CarId", "LicensePlate");

            return View();
        }

        [HttpPost("Create")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create(ServiceHistoryCreateViewModel model)
        {
            if (ModelState.IsValid)
            {
                var serviceHistoryDTO = new ServiceHistoryDTO
                {
                    CarId = model.CarId
                };
                var created = await this.serviceHistoryService.CreateAsync(serviceHistoryDTO);
                return RedirectToAction(nameof(Index));
            }

            var cars = await this.carService.GetAllWithoutServiceHistoryAsync();

            var carsView = new List<CarViewModel>();

            foreach (var car in cars)
            {
                carsView.Add(new CarViewModel
                {
                    CarId = car.Id,
                    CarIDNumber = car.VehicleIDNumber,
                    LicensePlate = car.LicensePlate,
                    OwnerName = car.OwnerName,
                    ManufacturerId = car.ManufacturerId,
                    ModelId = car.ModelId,
                    OwnerId = car.UserId,
                    YearOfManufacture = car.YearOfManufacture
                });
            }

            ViewData["CarId"] = new SelectList(carsView, "CarId", "LicensePlate", model.CarId);

            return View(model);
        }

        [HttpGet("Edit/{id}")]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int id)
        {
            var serviceHistory = await this.serviceHistoryService.GetAsync(id);

            var serviceHistoryView = new ServiceHistoryViewModel
            {
                ServiceHistoryId = serviceHistory.Id,
                CarId = serviceHistory.CarId
            };

            var cars = await this.carService.GetAllWithoutServiceHistoryAsync();

            var carsView = new List<CarViewModel>();

            foreach (var car in cars)
            {
                carsView.Add(new CarViewModel
                {
                    CarId = car.Id,
                    CarIDNumber = car.VehicleIDNumber,
                    LicensePlate = car.LicensePlate,
                    OwnerName = car.OwnerName,
                    ManufacturerId = car.ManufacturerId,
                    ModelId = car.ModelId,
                    OwnerId = car.UserId,
                    YearOfManufacture = car.YearOfManufacture
                });
            }

            ViewData["CarId"] = new SelectList(carsView, "CarId", "LicensePlate");

            return View(serviceHistoryView);

        }

        [HttpPost("Edit/{id}")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(ServiceHistoryViewModel serviceHistory)
        {

            if (ModelState.IsValid)
            {
                var serviceHistoryDTO = new ServiceHistoryDTO
                {
                    Id = serviceHistory.ServiceHistoryId,
                    CarId = serviceHistory.CarId
                };
                var updated = await serviceHistoryService.UpdateAsync(serviceHistoryDTO);
                return RedirectToAction(nameof(Index));
            }

            var cars = await this.carService.GetAllWithoutServiceHistoryAsync();

            var carsView = new List<CarViewModel>();

            foreach (var car in cars)
            {
                carsView.Add(new CarViewModel
                {
                    CarId = car.Id,
                    CarIDNumber = car.VehicleIDNumber,
                    LicensePlate = car.LicensePlate,
                    OwnerName = car.OwnerName,
                    ManufacturerId = car.ManufacturerId,
                    ModelId = car.ModelId,
                    OwnerId = car.UserId,
                    YearOfManufacture = car.YearOfManufacture
                });
            }

            ViewData["CarId"] = new SelectList(carsView, "CarId", "LicensePlate", serviceHistory.CarId);
            return View(serviceHistory);
        }

        [HttpGet("Delete/{id}")]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(int id)
        {
            var serviceHistory = await serviceHistoryService.GetAsync(id);
            var serviceHistoryView = new ServiceHistoryViewModel
            {
                ServiceHistoryId = serviceHistory.Id,
                CarId = serviceHistory.CarId
            };

            return View(serviceHistoryView);
        }

        [HttpPost("Delete/{id}")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(ServiceHistoryViewModel serviceHistory)
        {
            try
            {
                var result = await serviceHistoryService.DeleteAsync(serviceHistory.ServiceHistoryId);

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        [HttpGet("Details/{id}")]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> Details(int id)
        {
            try
            {
                var serviceHistory = await this.serviceHistoryService.GetAsync(id);

                var ordersView = new List<OrderViewModel>();
                foreach (var item in serviceHistory.Orders)
                {
                    var servicesView = new List<ServiceViewModel>();
                    foreach (var s in item.Services)
                    {
                        servicesView.Add(new ServiceViewModel
                        {
                            ServiceId = s.Id,
                            Name = s.Name,
                            Price = s.Price
                        });
                    }
                    ordersView.Add(new OrderViewModel
                    {
                        OrderId = item.Id,
                        OrderDate = item.OrderDate,
                        ServiceHistoryId = item.ServiceHistoryId,
                        ServicesOrdered = servicesView
                    });
                }
                var serviceHistoryView = new ServiceHistoryViewModel()
                {
                    ServiceHistoryId = serviceHistory.Id,
                    CarId = serviceHistory.CarId,
                    Orders = ordersView
                };

                return View(serviceHistoryView);
            }
            catch (Exception)
            {

                return View();

            }

        }
    }
}

VirtualCarGarage/VirtualCarGarage/Views/ServiceHistories/Create.cshtml
@model VirtualCarGarage.MVC.Models.ServiceHistoryCreateViewModel

@{
    ViewData["Title"] = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="container mt-3">
    <div class="text-center">
        <h1 class="text-dark font-weight-bolder">Create Service History</h1>
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="CarId" class="control-label"></label>
                <select asp-for="CarId" class="form-control" asp-items="ViewBag.CarId"></select>
                <span asp-validation-for="CarId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create Service History" class="btn btn-success" />
                <a asp-action="Index" class="btn btn-primary">Back</a>
            </div>
        </form>
    </div>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

VirtualCarGarage/VirtualCarGarage/Views/ServiceHistories/Delete.cshtml
@model VirtualCarGarage.MVC.Models.ServiceHistoryViewModel

@{
    ViewData["Title"] = "Delete";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="container mt-3">
    <div class="text-center">
        <h1 class="text-dark font-weight-bolder">Delete Service History</h1>
        <hr />
        <h3>Are you sure you want to delete Service History with Id: @Model.ServiceHistoryId from the system?</h3>
        <div class="text-dark">
            <form asp-action="Delete">
                <input type="hidden" asp-for="ServiceHistoryId" />
                <input type="submit" value="Delete" class="btn btn-danger" /> |
                <a asp-action="Index" class="btn btn-primary">Back</a>
            </form>
        </div>
    </div>
</div>

VirtualCarGarage/VirtualCarGarage/Views/ServiceHistories/Details.cshtml
@model VirtualCarGarage.MVC.Models.ServiceHistoryViewModel;
@using Microsoft.AspNetCore.Identity
@using VirtualCarGarage.Data.Models

@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager

@{ ViewData["Title"] = "Details"; }
@{ Layout = "~/Views/Shared/_Layout.cshtml"; }


<div class="container mt-3">
    <div class="text-center">

        @if (Model == null)
        {
            <h3 class="text-dark font-weight-bolder">No Service History registered.</h3>
            <a asp-controller="ServiceHistories" asp-action="Create" class="btn btn-success">Create</a>
            <a asp-controller="Cars" asp-action="Index" class="btn btn-primary">Back</a>}
        @if (Model != null)
        {
            <h1 class="text-dark font-weight-bolder">Service History</h1>
            <table class="table">
                <thead>
                    <tr>
                        <th>
                            @Html.DisplayNameFor(model => model.ServiceHistoryId)
                        </th>
                        <th>
                            @Html.DisplayNameFor(model => model.CarId)
                        </th>
                        <th>
                            @Html.DisplayNameFor(model => model.Orders)
                        </th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>
                            @Html.DisplayFor(modelItem => Model.ServiceHistoryId)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => Model.CarId)
                        </td>
                        <td>
                            <div class="dropdown">
                                <button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown">
                                    Select Order Date
                                </button>
                                <div class="dropdown-menu">
                                    @if (Model.Orders.Count == 0)
                                    {
                                        <a class="dropdown-item">No Orders Registered</a> }
                                    else
                                    {
                                        @foreach (var item in Model.Orders)
                                        {
                                            <a class="dropdown-item" href='@Url.Action("Details", "Orders", new { id = item.OrderId })'>Date: @item.OrderDate.ToShortDateString()</a>}}
                                </div>
                            </div>
                        </td>


                        @if (User.IsInRole("Admin"))
                        {
                            <td>
                                <a asp-action="Edit" asp-route-id="@Model.ServiceHistoryId">Edit</a> |
                                <a asp-action="Delete" asp-route-id="@Model.ServiceHistoryId">Delete</a>
                            </td>
}
                    </tr>
                </tbody>
            </table>}
    </div>
</div>

VirtualCarGarage/VirtualCarGarage/Views/ServiceHistories/Edit.cshtml
@model VirtualCarGarage.MVC.Models.ServiceHistoryViewModel
@{
    ViewData["Title"] = "Edit";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="container mt-3">
    <div class="text-center">
        <h1 class="text-dark font-weight-bolder">Edit Service History</h1>
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="ServiceHistoryId" />
            <div class="form-group">
                <label asp-for="CarId" class="control-label"></label>
                <select asp-for="CarId" class="form-control" asp-items="ViewBag.CarId"></select>
                <span asp-validation-for="CarId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
                <a asp-action="Index" class="btn btn-primary">Back</a>
            </div>
        </form>
    </div>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
    }

VirtualCarGarage/VirtualCarGarage/Views/ServiceHistories/Index.cshtml
@model List<VirtualCarGarage.MVC.Models.ServiceHistoryViewModel>;
@using Microsoft.AspNetCore.Identity
@using VirtualCarGarage.Data.Models

@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager

@{ ViewData["Title"] = "Index"; }
@{ Layout = "~/Views/Shared/_Layout.cshtml"; }


<div class="container mt-3">
    <div class="text-center">
        <h1 class="text-dark font-weight-bolder">Service Histories</h1>

        <p>
            <a class="text-primary font-weight-bolder" asp-action="Create">Create</a>
        </p>
        @if (Model.Count == 0)
        {
<h3 class="text-dark font-weight-bolder">No Service Histories registered.</h3>}
        @if (Model.Count != 0)
        {
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.First().ServiceHistoryId)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.First().CarId)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
<tr>
    <td>
        @Html.DisplayFor(modelItem => item.ServiceHistoryId)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.CarId)
    </td>
    <td>
        <a asp-action="Edit" asp-route-id="@item.ServiceHistoryId">Edit</a> |
        <a asp-action="Details" asp-route-id="@item.ServiceHistoryId">Details</a> |
        <a asp-action="Delete" asp-route-id="@item.ServiceHistoryId">Delete</a>
    </td>
</tr>}
    </tbody>
</table>}
    </div>
    <div class="text-center">
        <a asp-controller="Home" asp-action="Index" class="btn btn-primary">Back</a>
    </div>
</div>